53df93c55810c4a9dbfbb2c87352ffbd5921e2a6
[arvados.git] / build / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 COLUMNS=80
6 . `dirname "$(readlink -f "$0")"`/run-library.sh
7
8 read -rd "\000" helpmessage <<EOF
9 $(basename $0): Install and test Arvados components.
10
11 Exit non-zero if any tests fail.
12
13 Syntax:
14         $(basename $0) WORKSPACE=/path/to/arvados [options]
15
16 Options:
17
18 --skip FOO     Do not test the FOO component.
19 --only FOO     Do not test anything except the FOO component.
20 --temp DIR     Install components and dependencies under DIR instead of
21                making a new temporary directory. Implies --leave-temp.
22 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
23                Instead, show the path to give as --temp to reuse them in
24                subsequent invocations.
25 --skip-install Do not run any install steps. Just run tests.
26                You should provide GOPATH, GEMHOME, and VENVDIR options
27                from a previous invocation if you use this option.
28 --only-install Run specific install step
29 --short        Skip (or scale down) some slow tests.
30 WORKSPACE=path Arvados source tree to test.
31 CONFIGSRC=path Dir with api server config files to copy into source tree.
32                (If none given, leave config files alone in source tree.)
33 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
34                Restrict apiserver tests to the given file
35 sdk/python_test="--test-suite test.test_keep_locator"
36                Restrict Python SDK tests to the given class
37 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
38                Restrict Workbench tests to the given file
39 services/arv-git-httpd_test="-check.vv"
40                Show all log messages, even when tests pass (also works
41                with services/keepstore_test etc.)
42 ARVADOS_DEBUG=1
43                Print more debug messages
44 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
45                *_test, and other examples shown above.
46
47 Assuming --skip-install is not given, all components are installed
48 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
49 test suites depend on other components being installed, and installing
50 everything tends to be quicker than debugging dependencies.
51
52 As a special concession to the current CI server config, CONFIGSRC
53 defaults to $HOME/arvados-api-server if that directory exists.
54
55 More information and background:
56
57 https://arvados.org/projects/arvados/wiki/Running_tests
58
59 Available tests:
60
61 apps/workbench
62 apps/workbench_benchmark
63 apps/workbench_profile
64 doc
65 services/api
66 services/arv-git-httpd
67 services/crunchstat
68 services/dockercleaner
69 services/fuse
70 services/keep-web
71 services/keepproxy
72 services/keepstore
73 services/login-sync
74 services/nodemanager
75 services/crunch-run
76 services/crunch-dispatch-local
77 services/crunch-dispatch-slurm
78 sdk/cli
79 sdk/pam
80 sdk/python
81 sdk/ruby
82 sdk/go/arvadosclient
83 sdk/go/keepclient
84 sdk/go/manifest
85 sdk/go/blockdigest
86 sdk/go/streamer
87 sdk/go/crunchrunner
88 sdk/cwl
89 tools/crunchstat-summary
90 tools/keep-rsync
91 tools/keep-block-check
92
93 EOF
94
95 # First make sure to remove any ARVADOS_ variables from the calling
96 # environment that could interfere with the tests.
97 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
98
99 # Reset other variables that could affect our [tests'] behavior by
100 # accident.
101 GITDIR=
102 GOPATH=
103 VENVDIR=
104 VENV3DIR=
105 PYTHONPATH=
106 GEMHOME=
107 PERLINSTALLBASE=
108
109 short=
110 skip_install=
111 temp=
112 temp_preserve=
113
114 clear_temp() {
115     if [[ -z "$temp" ]]; then
116         # we didn't even get as far as making a temp dir
117         :
118     elif [[ -z "$temp_preserve" ]]; then
119         rm -rf "$temp"
120     else
121         echo "Leaving behind temp dirs in $temp"
122     fi
123 }
124
125 fatal() {
126     clear_temp
127     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
128     exit 1
129 }
130
131 exit_cleanly() {
132     trap - INT
133     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
134     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
135     stop_services
136     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
137     report_outcomes
138     clear_temp
139     exit ${#failures}
140 }
141
142 sanity_checks() {
143     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
144         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
145     echo Checking dependencies:
146     echo -n 'virtualenv: '
147     virtualenv --version \
148         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
149     echo -n 'go: '
150     go version \
151         || fatal "No go binary. See http://golang.org/doc/install"
152     echo -n 'gcc: '
153     gcc --version | egrep ^gcc \
154         || fatal "No gcc. Try: apt-get install build-essential"
155     echo -n 'fuse.h: '
156     find /usr/include -wholename '*fuse/fuse.h' \
157         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
158     echo -n 'pyconfig.h: '
159     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
160         || fatal "No pyconfig.h. Try: apt-get install python-dev"
161     echo -n 'nginx: '
162     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
163         || fatal "No nginx. Try: apt-get install nginx"
164     echo -n 'perl: '
165     perl -v | grep version \
166         || fatal "No perl. Try: apt-get install perl"
167     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
168         echo -n "perl $mod: "
169         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
170             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
171     done
172     echo -n 'gitolite: '
173     which gitolite \
174         || fatal "No gitolite. Try: apt-get install gitolite3"
175 }
176
177 rotate_logfile() {
178   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
179   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
180   if [[ -f "$1/$2" ]]; then
181     THEDATE=`date +%Y%m%d%H%M%S`
182     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
183     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
184   fi
185 }
186
187 declare -a failures
188 declare -A skip
189 declare -A testargs
190 skip[apps/workbench_profile]=1
191
192 while [[ -n "$1" ]]
193 do
194     arg="$1"; shift
195     case "$arg" in
196         --help)
197             echo >&2 "$helpmessage"
198             echo >&2
199             exit 1
200             ;;
201         --skip)
202             skipwhat="$1"; shift
203             skip[$skipwhat]=1
204             ;;
205         --only)
206             only="$1"; skip[$1]=""; shift
207             ;;
208         --short)
209             short=1
210             ;;
211         --skip-install)
212             skip_install=1
213             ;;
214         --only-install)
215             skip_install=1
216             only_install="$1"; shift
217             ;;
218         --temp)
219             temp="$1"; shift
220             temp_preserve=1
221             ;;
222         --leave-temp)
223             temp_preserve=1
224             ;;
225         --retry)
226             retry=1
227             ;;
228         *_test=*)
229             suite="${arg%%_test=*}"
230             args="${arg#*=}"
231             testargs["$suite"]="$args"
232             ;;
233         *=*)
234             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
235             ;;
236         *)
237             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
238             exit 1
239             ;;
240     esac
241 done
242
243 start_api() {
244     echo 'Starting API server...'
245     cd "$WORKSPACE" \
246         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
247         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
248         && export ARVADOS_TEST_API_INSTALLED="$$" \
249         && (env | egrep ^ARVADOS)
250 }
251
252 start_nginx_proxy_services() {
253     echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
254     cd "$WORKSPACE" \
255         && python sdk/python/tests/run_test_server.py start_keep_proxy \
256         && python sdk/python/tests/run_test_server.py start_keep-web \
257         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
258         && python sdk/python/tests/run_test_server.py start_nginx \
259         && export ARVADOS_TEST_PROXY_SERVICES=1
260 }
261
262 stop_services() {
263     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
264         unset ARVADOS_TEST_PROXY_SERVICES
265         cd "$WORKSPACE" \
266             && python sdk/python/tests/run_test_server.py stop_nginx \
267             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
268             && python sdk/python/tests/run_test_server.py stop_keep-web \
269             && python sdk/python/tests/run_test_server.py stop_keep_proxy
270     fi
271     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
272         unset ARVADOS_TEST_API_HOST
273         cd "$WORKSPACE" \
274             && python sdk/python/tests/run_test_server.py stop
275     fi
276 }
277
278 interrupt() {
279     failures+=("($(basename $0) interrupted)")
280     exit_cleanly
281 }
282 trap interrupt INT
283
284 sanity_checks
285
286 echo "WORKSPACE=$WORKSPACE"
287
288 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
289     # Jenkins expects us to use this by default.
290     CONFIGSRC="$HOME/arvados-api-server"
291 fi
292
293 # Clean up .pyc files that may exist in the workspace
294 cd "$WORKSPACE"
295 find -name '*.pyc' -delete
296
297 if [[ -z "$temp" ]]; then
298     temp="$(mktemp -d)"
299 fi
300
301 # Set up temporary install dirs (unless existing dirs were supplied)
302 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
303 do
304     if [[ -z "${!tmpdir}" ]]; then
305         eval "$tmpdir"="$temp/$tmpdir"
306     fi
307     if ! [[ -d "${!tmpdir}" ]]; then
308         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
309     fi
310 done
311
312 setup_ruby_environment() {
313     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
314       source "$HOME/.rvm/scripts/rvm"
315       using_rvm=true
316     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
317       source "/usr/local/rvm/scripts/rvm"
318       using_rvm=true
319     else
320       using_rvm=false
321     fi
322
323     if [[ "$using_rvm" == true ]]; then
324         # If rvm is in use, we can't just put separate "dependencies"
325         # and "gems-under-test" paths to GEM_PATH: passenger resets
326         # the environment to the "current gemset", which would lose
327         # our GEM_PATH and prevent our test suites from running ruby
328         # programs (for example, the Workbench test suite could not
329         # boot an API server or run arv). Instead, we have to make an
330         # rvm gemset and use it for everything.
331
332         [[ `type rvm | head -n1` == "rvm is a function" ]] \
333             || fatal 'rvm check'
334
335         # Put rvm's favorite path back in first place (overriding
336         # virtualenv, which just put itself there). Ignore rvm's
337         # complaint about not being in first place already.
338         rvm use @default 2>/dev/null
339
340         # Create (if needed) and switch to an @arvados-tests
341         # gemset. (Leave the choice of ruby to the caller.)
342         rvm use @arvados-tests --create \
343             || fatal 'rvm gemset setup'
344
345         rvm env
346     else
347         # When our "bundle install"s need to install new gems to
348         # satisfy dependencies, we want them to go where "gem install
349         # --user-install" would put them. (However, if the caller has
350         # already set GEM_HOME, we assume that's where dependencies
351         # should be installed, and we should leave it alone.)
352
353         if [ -z "$GEM_HOME" ]; then
354             user_gempath="$(gem env gempath)"
355             export GEM_HOME="${user_gempath%%:*}"
356         fi
357         PATH="$(gem env gemdir)/bin:$PATH"
358
359         # When we build and install our own gems, we install them in our
360         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
361         # PATH so integration tests prefer them over other versions that
362         # happen to be installed in $user_gempath, system dirs, etc.
363
364         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
365         PATH="$tmpdir_gem_home/bin:$PATH"
366         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
367
368         echo "Will install dependencies to $(gem env gemdir)"
369         echo "Will install arvados gems to $tmpdir_gem_home"
370         echo "Gem search path is GEM_PATH=$GEM_PATH"
371     fi
372 }
373
374 with_test_gemset() {
375     if [[ "$using_rvm" == true ]]; then
376         "$@"
377     else
378         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
379     fi
380 }
381
382 gem_uninstall_if_exists() {
383     if gem list "$1\$" | egrep '^\w'; then
384         gem uninstall --force --all --executables "$1"
385     fi
386 }
387
388 setup_virtualenv() {
389     local venvdest="$1"; shift
390     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
391         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
392     fi
393     if [[ $("$venvdest/bin/python" --version 2>&1) =~ \ 3\.[012]\. ]]; then
394         # pip 8.0.0 dropped support for python 3.2, e.g., debian wheezy
395         "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7,<8'
396     else
397         "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
398     fi
399     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
400     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
401 }
402
403 export PERLINSTALLBASE
404 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
405
406 export GOPATH
407 mkdir -p "$GOPATH/src/git.curoverse.com"
408 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
409     || fatal "symlink failed"
410
411 setup_virtualenv "$VENVDIR" --python python2.7
412 . "$VENVDIR/bin/activate"
413
414 # Needed for run_test_server.py which is used by certain (non-Python) tests.
415 pip freeze 2>/dev/null | egrep ^PyYAML= \
416     || pip install PyYAML >/dev/null \
417     || fatal "pip install PyYAML failed"
418
419 # Preinstall forked version of libcloud, because nodemanager "pip install"
420 # won't pick it up by default.
421 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
422     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
423     || fatal "pip install apache-libcloud failed"
424
425 # This will help people who reuse --temp dirs when we upgrade to llfuse 0.42
426 if egrep -q 'llfuse.*>= *0\.42' "$WORKSPACE/services/fuse/setup.py"; then
427     # Uninstall old llfuse, because services/fuse "pip install" won't
428     # upgrade it by default.
429     if pip freeze | egrep '^llfuse==0\.41\.'; then
430         yes | pip uninstall 'llfuse<0.42'
431     fi
432 fi
433
434 # Deactivate Python 2 virtualenv
435 deactivate
436
437 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
438 # Otherwise, skip dependent tests.
439 PYTHON3=$(which python3)
440 if [ "0" = "$?" ]; then
441     setup_virtualenv "$VENV3DIR" --python python3
442 else
443     PYTHON3=
444     skip[services/dockercleaner]=1
445     cat >&2 <<EOF
446
447 Warning: python3 could not be found
448 services/dockercleaner install and tests will be skipped
449
450 EOF
451 fi
452
453 # Reactivate Python 2 virtualenv
454 . "$VENVDIR/bin/activate"
455
456 # Note: this must be the last time we change PATH, otherwise rvm will
457 # whine a lot.
458 setup_ruby_environment
459
460 echo "PATH is $PATH"
461
462 if ! which bundler >/dev/null
463 then
464     gem install --user-install bundler || fatal 'Could not install bundler'
465 fi
466
467 retry() {
468     while ! ${@} && [[ "$retry" == 1 ]]
469     do
470         read -p 'Try again? [Y/n] ' x
471         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
472         then
473             break
474         fi
475     done
476 }
477
478 do_test() {
479     retry do_test_once ${@}
480 }
481
482 do_test_once() {
483     unset result
484     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
485     then
486         title "Running $1 tests"
487         timer_reset
488         if [[ "$2" == "go" ]]
489         then
490             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
491             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
492             # We do "go get -t" here to catch compilation errors
493             # before trying "go test". Otherwise, coverage-reporting
494             # mode makes Go show the wrong line numbers when reporting
495             # compilation errors.
496             if [[ -n "${testargs[$1]}" ]]
497             then
498                 # "go test -check.vv giturl" doesn't work, but this
499                 # does:
500                 cd "$WORKSPACE/$1" && \
501                     go get -t "git.curoverse.com/arvados.git/$1" && \
502                     go test ${short:+-short} ${coverflags[@]} ${testargs[$1]}
503             else
504                 # The above form gets verbose even when testargs is
505                 # empty, so use this form in such cases:
506                 go get -t "git.curoverse.com/arvados.git/$1" && \
507                     go test ${short:+-short} ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
508             fi
509             result="$?"
510             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
511             rm "$WORKSPACE/tmp/.$covername.tmp"
512         elif [[ "$2" == "pip" ]]
513         then
514             # $3 can name a path directory for us to use, including trailing
515             # slash; e.g., the bin/ subdirectory of a virtualenv.
516             cd "$WORKSPACE/$1" \
517                 && "${3}python" setup.py ${short:+--short-tests-only} test ${testargs[$1]}
518         elif [[ "$2" != "" ]]
519         then
520             "test_$2"
521         else
522             "test_$1"
523         fi
524         result=${result:-$?}
525         checkexit $result "$1 tests"
526         title "End of $1 tests (`timer`)"
527         return $result
528     else
529         title "Skipping $1 tests"
530     fi
531 }
532
533 do_install() {
534     retry do_install_once ${@}
535 }
536
537 do_install_once() {
538     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
539     then
540         title "Running $1 install"
541         timer_reset
542         if [[ "$2" == "go" ]]
543         then
544             go get -t "git.curoverse.com/arvados.git/$1"
545         elif [[ "$2" == "pip" ]]
546         then
547             # $3 can name a path directory for us to use, including trailing
548             # slash; e.g., the bin/ subdirectory of a virtualenv.
549
550             # Need to change to a different directory after creating
551             # the source dist package to avoid a pip bug.
552             # see https://arvados.org/issues/5766 for details.
553
554             # Also need to install twice, because if it believes the package is
555             # already installed, pip it won't install it.  So the first "pip
556             # install" ensures that the dependencies are met, the second "pip
557             # install" ensures that we've actually installed the local package
558             # we just built.
559             cd "$WORKSPACE/$1" \
560                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
561                 && cd "$WORKSPACE" \
562                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
563                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
564         elif [[ "$2" != "" ]]
565         then
566             "install_$2"
567         else
568             "install_$1"
569         fi
570         result=$?
571         checkexit $result "$1 install"
572         title "End of $1 install (`timer`)"
573         return $result
574     else
575         title "Skipping $1 install"
576     fi
577 }
578
579 bundle_install_trylocal() {
580     (
581         set -e
582         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
583         if ! bundle install --local --no-deployment; then
584             echo "(Running bundle install again, without --local.)"
585             bundle install --no-deployment
586         fi
587         bundle package --all
588     )
589 }
590
591 install_doc() {
592     cd "$WORKSPACE/doc" \
593         && bundle_install_trylocal \
594         && rm -rf .site
595 }
596 do_install doc
597
598 install_gem() {
599     gemname=$1
600     srcpath=$2
601     with_test_gemset gem_uninstall_if_exists "$gemname" \
602         && cd "$WORKSPACE/$srcpath" \
603         && bundle_install_trylocal \
604         && gem build "$gemname.gemspec" \
605         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
606 }
607
608 install_ruby_sdk() {
609     install_gem arvados sdk/ruby
610 }
611 do_install sdk/ruby ruby_sdk
612
613 install_perl_sdk() {
614     cd "$WORKSPACE/sdk/perl" \
615         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
616         && make install INSTALLDIRS=perl
617 }
618 do_install sdk/perl perl_sdk
619
620 install_cli() {
621     install_gem arvados-cli sdk/cli
622 }
623 do_install sdk/cli cli
624
625 install_login-sync() {
626     install_gem arvados-login-sync services/login-sync
627 }
628 do_install services/login-sync login-sync
629
630 # Install the Python SDK early. Various other test suites (like
631 # keepproxy) bring up run_test_server.py, which imports the arvados
632 # module. We can't actually *test* the Python SDK yet though, because
633 # its own test suite brings up some of those other programs (like
634 # keepproxy).
635 declare -a pythonstuff
636 pythonstuff=(
637     sdk/pam
638     sdk/python
639     sdk/cwl
640     services/fuse
641     services/nodemanager
642     tools/crunchstat-summary
643     )
644 for p in "${pythonstuff[@]}"
645 do
646     do_install "$p" pip
647 done
648 if [ -n "$PYTHON3" ]; then
649     do_install services/dockercleaner pip "$VENV3DIR/bin/"
650 fi
651
652 install_apiserver() {
653     cd "$WORKSPACE/services/api" \
654         && RAILS_ENV=test bundle_install_trylocal
655
656     rm -f config/environments/test.rb
657     cp config/environments/test.rb.example config/environments/test.rb
658
659     if [ -n "$CONFIGSRC" ]
660     then
661         for f in database.yml application.yml
662         do
663             cp "$CONFIGSRC/$f" config/ || fatal "$f"
664         done
665     fi
666
667     # Fill in a random secret_token and blob_signing_key for testing
668     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
669     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
670
671     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
672     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
673
674     # Set up empty git repo (for git tests)
675     GITDIR=$(mktemp -d)
676     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
677
678     rm -rf $GITDIR
679     mkdir -p $GITDIR/test
680     cd $GITDIR/test \
681         && git init \
682         && git config user.email "jenkins@ci.curoverse.com" \
683         && git config user.name "Jenkins, CI" \
684         && touch tmp \
685         && git add tmp \
686         && git commit -m 'initial commit'
687
688     # Clear out any lingering postgresql connections to the test
689     # database, so that we can drop it. This assumes the current user
690     # is a postgresql superuser.
691     cd "$WORKSPACE/services/api" \
692         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
693         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
694
695     cd "$WORKSPACE/services/api" \
696         && RAILS_ENV=test bundle exec rake db:drop \
697         && RAILS_ENV=test bundle exec rake db:setup \
698         && RAILS_ENV=test bundle exec rake db:fixtures:load
699 }
700 do_install services/api apiserver
701
702 declare -a gostuff
703 gostuff=(
704     sdk/go/arvadosclient
705     sdk/go/blockdigest
706     sdk/go/manifest
707     sdk/go/streamer
708     sdk/go/crunchrunner
709     services/arv-git-httpd
710     services/crunchstat
711     services/keep-web
712     services/keepstore
713     sdk/go/keepclient
714     services/keepproxy
715     services/datamanager/summary
716     services/datamanager/collection
717     services/datamanager/keep
718     services/datamanager
719     services/crunch-dispatch-local
720     services/crunch-dispatch-slurm
721     services/crunch-run
722     tools/keep-rsync
723     tools/keep-block-check
724     )
725 for g in "${gostuff[@]}"
726 do
727     do_install "$g" go
728 done
729
730 install_workbench() {
731     cd "$WORKSPACE/apps/workbench" \
732         && mkdir -p tmp/cache \
733         && RAILS_ENV=test bundle_install_trylocal
734 }
735 do_install apps/workbench workbench
736
737 test_doclinkchecker() {
738     (
739         set -e
740         cd "$WORKSPACE/doc"
741         ARVADOS_API_HOST=qr1hi.arvadosapi.com
742         # Make sure python-epydoc is installed or the next line won't
743         # do much good!
744         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
745     )
746 }
747 do_test doc doclinkchecker
748
749 stop_services
750
751 test_apiserver() {
752     rm -f "$WORKSPACE/services/api/git-commit.version"
753     cd "$WORKSPACE/services/api" \
754         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
755 }
756 do_test services/api apiserver
757
758 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
759 # because we don't need to start up the api server for subsequent tests.
760 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
761   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
762   exit_cleanly
763 fi
764
765 start_api
766
767 test_ruby_sdk() {
768     cd "$WORKSPACE/sdk/ruby" \
769         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
770 }
771 do_test sdk/ruby ruby_sdk
772
773 test_cli() {
774     cd "$WORKSPACE/sdk/cli" \
775         && mkdir -p /tmp/keep \
776         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
777 }
778 do_test sdk/cli cli
779
780 test_login-sync() {
781     cd "$WORKSPACE/services/login-sync" \
782         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
783 }
784 do_test services/login-sync login-sync
785
786 for p in "${pythonstuff[@]}"
787 do
788     do_test "$p" pip
789 done
790 do_test services/dockercleaner pip "$VENV3DIR/bin/"
791
792 for g in "${gostuff[@]}"
793 do
794     do_test "$g" go
795 done
796
797 test_workbench() {
798     start_nginx_proxy_services \
799         && cd "$WORKSPACE/apps/workbench" \
800         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
801 }
802 do_test apps/workbench workbench
803
804 test_workbench_benchmark() {
805     start_nginx_proxy_services \
806         && cd "$WORKSPACE/apps/workbench" \
807         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
808 }
809 do_test apps/workbench_benchmark workbench_benchmark
810
811 test_workbench_profile() {
812     start_nginx_proxy_services \
813         && cd "$WORKSPACE/apps/workbench" \
814         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
815 }
816 do_test apps/workbench_profile workbench_profile
817
818 exit_cleanly